# Copyright (c) 2009 gocept gmbh & co. kg
# See also LICENSE.txt

import grok
import gocept.directory.interfaces
import zope.security.interfaces

grok.context(gocept.directory.interfaces.IResourceGroup)


class AccessRing1(grok.Permission):
    grok.name('gocept.directory.AccessRing1')


class Ring1(grok.XMLRPC):

    grok.require(AccessRing1)

    def lookup_node(self, lookup_name):
        for node in self.context.nodes:
            if node.name == lookup_name:
                break
        else:
            raise zope.security.interfaces.Unauthorized()

        request_node = zope.component.getUtility(
            gocept.directory.interfaces.INode,
            name=self.request.principal.id)
        if request_node.resource_group != self.context:
            raise zope.security.interfaces.Unauthorized()

        r0 = gocept.directory.api.ring0.Ring0()
        r0.context = self.context
        r0.request = self.request
        return r0.lookup_node(lookup_name)

    def list_resource_groups(self):
        return [self.context.name]
