# Copyright (c) 2010-2011 gocept gmbh & co. kg
# See also LICENSE.txt

from zope.app.zopeappgenerations import getRootFolder
import gocept.directory.interfaces
import gocept.reference
import grok
import sys
import types
import zope.app.component.hooks


class GroupStub(grok.Container):
    grok.baseclass()

    members = gocept.reference.ReferenceCollection(ensure_integrity=True)


class PersonStub(grok.Container):
    grok.baseclass()


def evolve(context):
    """Remove old people and group objects."""
    root = getRootFolder(context)
    d = root['directory']
    zope.app.component.hooks.setSite(d)
    try:
        # Patch classes for Group and Person so we get real objects, not
        # Broken.
        module = types.ModuleType('stubmodule')
        module.Person = PersonStub
        module.Group = GroupStub

        sys.modules['gocept.directory.person'] = module
        gocept.directory.person = module
        sys.modules['gocept.directory.group'] = module
        gocept.directory.group = module

        for cls in [GroupStub, PersonStub]:
            for name, candidate in list(d.items()):
                if isinstance(candidate, cls):
                    del d[name]

    finally:
        zope.app.component.hooks.setSite(None)
