# Copyright (c) 2011 gocept gmbh & co. kg
# See also LICENSE.txt

from zope.app.authentication import httpplugins
from zope.app.zopeappgenerations import getRootFolder
import persistent
import zope.app.component.hooks


class AuthPluginStub(persistent.Persistent):
    pass


def evolve(context):
    """Remove old persistent auth plugins."""
    old_auth_p = httpplugins.HTTPBasicAuthCredentialsPlugin
    httpplugins.HTTPBasicAuthCredentialsPlugin = AuthPluginStub
    root = getRootFolder(context)
    d = root['directory']
    zope.app.component.hooks.setSite(d)
    try:
        auth = d.getSiteManager()['PluggableAuthentication']
        del auth['basic-auth']
        del auth['machine-logins']
    finally:
        httpplugins.HTTPBasicAuthCredentialsPlugin = old_auth_p
