# Copyright (c) 2009 gocept gmbh & co. kg
# See also LICENSE.txt

import gocept.reference.interfaces


def fix_inconsistent_address_resource_references(directory):
    # Searches all addresses whether their resource reference can be resolved.
    # If it can't, look for a resource/nic which has a reference to this
    # address and update it.
    for network in directory.networks:
        for address in network.addresses:
            try:
                address.resource
            except gocept.reference.interfaces.LookupError:
                pass
            else:
                continue

            for node in directory.nodes:
                for nic in node.nics:
                    if address in nic.addresses:
                        address.resource = nic
                        break
                else:
                    continue
                break
